import javax.persistence.*;
import java.util.*;

public class TestClient {
  @PersistenceUnit private static EntityManagerFactory emf;

  public static void main(String[] args) throws Exception {

    if(emf == null) {
       emf = Persistence.createEntityManagerFactory("pu1");
    }
    EntityManager em = emf.createEntityManager();
    em.getTransaction().begin();

    Geocache mgc, tgc; 
    String name = args[0];
    String ext = "ext1";

    ArrayList<Coordinate> cs = new ArrayList<Coordinate>();
    Coordinate c1, c2,c3; 
    c1 = new Coordinate ("c1", "x1", "y1");
    c2 = new Coordinate ("c2", "x2", "y2");
    c3 = new Coordinate ("c3", "x3", "y3");
    cs.add(c1);
    cs.add(c2);

    System.out.println("name="+name);
    mgc = new MultiGeocache();
    mgc.setName(name);
    ((MultiGeocache)mgc).setExt(ext);
    ((MultiGeocache)mgc).setCoordinates(cs);

    tgc = new TraditionalGeocache();
    tgc.setName(name);
    ((TraditionalGeocache)tgc).setExt(ext);
    ((TraditionalGeocache)tgc).setCoordinate(c3);

    em.persist(mgc);
    System.out.println(mgc);
    em.persist(tgc);
    System.out.println(tgc);

    em.getTransaction().commit();
    System.out.println("mgc.surrogate="+mgc.surrogate);
    System.out.println("tgc.surrogate="+tgc.surrogate);

    em.close();
  }

}

